from .frame import Frame
from .logic import decide_src_plt_cfg
from .utils import bind


class Actor:

    def __init__(self, pvname):
        self.pvname = pvname
        src, plt, cfg = decide_src_plt_cfg(pvname)
        self.src = src
        self.plt = plt
        self.cfg = cfg
        self.frm = frm = Frame(plt, cfg)
        self.cache = cache = src.cache.get_view()

        cfg.sp_cache_size.value = cache.size
        bind(cfg.sp_cache_size, self.do_update_cache_size)

        cfg.connect(plt)


    def delete(self):
        self.cache = None

    def do_update_cache_size(self, new):
        self.cache.set_size(new)

    def update(self): #TODO: check for empty cache?
        self.plt.set(*self.cache)

    def __repr__(self):
        return f"Actor: {self.pvname}"



