from bokeh.models import Div, Spinner

from ..buki import Column, Row
from ..utils import adjust_margin
from ..widgets import Checkbox


class ConfigDialog1D(Column):

    def __init__(self):
        self.sp_cache_size = sp_cache_size = Spinner(title="Cache size:")

        self.cb_curves_latest  = cb_curves_latest  = Checkbox(label="Latest Curve")
        self.cb_curves_average = cb_curves_average = Checkbox(label="Average Curve")

        self.cb_error_bars  = cb_error_bars  = Checkbox(label="Error Bars")
        self.cb_error_bands = cb_error_bands = Checkbox(label="Error Bands")

        super().__init__(
            sp_cache_size,
            make_entry("Curves", cb_curves_latest, cb_curves_average),
            make_entry("Errors", cb_error_bars, cb_error_bands)
        )

    def connect(self, plt):
        self.cb_curves_latest.active  = plt.line_latest.visible
        self.cb_curves_average.active = plt.line_average.visible
        self.cb_error_bands.active    = plt.errband_latest.visible
        self.cb_error_bars.active     = plt.errbars_latest.visible

        self.cb_curves_latest.on_click(plt.show_curve_latest)
        self.cb_curves_average.on_click(plt.show_curve_average)
        self.cb_error_bands.on_click(plt.show_error_bands)
        self.cb_error_bars.on_click(plt.show_error_bars)



def make_entry(title, *args):
    title += ":"
    header = Div(text=title)
    adjust_margin(header, bottom=-5)
    return Column(header, Row(*args))



#TODO:
#- log x
#- log y



