from bokeh.models import Select, Spinner

from ..buki import Column, Row
from ..colormaps import cmaps
from ..utils import bind
from ..widgets import Checkbox


class ConfigDialog2D(Column):

    def __init__(self):
        self.sp_cache_size = sp_cache_size = Spinner(title="Cache size:")
        sp_cache_size.disabled = True # 2D plot only shows the latest image
        self.sel_cmap_palette = sel_cmap_palette = Select(title="Colormap", options=sorted(cmaps))
        self.cb_cmap_reverse = cb_cmap_reverse = Checkbox(label="Reverse Colormap")
        self.sp_vmin = sp_vmin = Spinner(title="Minimum Value")
        self.sp_vmax = sp_vmax = Spinner(title="Maximum Value")
        self.sp_binning = sp_binning = Spinner(title="Binning", low=1)
        super().__init__(
            sp_cache_size,
            sel_cmap_palette,
            cb_cmap_reverse,
            Row(sp_vmin, sp_vmax),
            sp_binning
        )

    def connect(self, plt):
        self.sel_cmap_palette.value = plt.cmap_palette
        self.cb_cmap_reverse.active = plt.cmap_reverse

        self.sp_binning.value = plt.binning

        bind(self.sel_cmap_palette, plt.change_cmap_palette)
        self.cb_cmap_reverse.on_click(plt.change_cmap_reverse)

        bind(self.sp_vmin,    plt.change_vmin)
        bind(self.sp_vmax,    plt.change_vmax)
        bind(self.sp_binning, plt.change_binning)



#TODO:
#- log z



