from types import SimpleNamespace
from epics import PV


class PVCollection:
    """
    Creates all PVs, then waits for connection
    Disconnects all PVs
    """

    def __init__(self, name, **kwargs):
        self.name = name
#        self.pvnames = SimpleNamespace(**kwargs)
        self.pv_dict = pv_dict = {k: PV(v) for k, v in kwargs.items()}
        self.pvs = SimpleNamespace(**pv_dict)

    def __str__(self):
        return self.name

    def disconnect(self):
        for pv in self.pv_dict.values(): #TODO is it better to use: pv_dict -> pvs.__dict__
            pv.disconnect()

    @property
    def is_connected(self):
        return all(pv.wait_for_connection() for pv in self.pv_dict.values())



