from epics import PV

from .cachedsource import CachedSource


class Source(CachedSource, PV):
    """
    PV, but waits for connection on creation
    """

    def __init__(self, pvname, *args, **kwargs):
        self.name = pvname
        PV.__init__(self, pvname, *args, **kwargs)
        CachedSource.__init__(self, size=100)

    @property
    def is_connected(self):
        return self.wait_for_connection()



