from logzero import logger as log


def bind(obj, handler):
    obj.on_change("value", cb(handler))

def cb(handler):
    fn = handler.__name__
    def wrapper(attr, old, new):
        log.debug(f"Callback {fn}: attribute {repr(attr)} changed from {repr(old)} to {repr(new)}")
        handler(new)
    return wrapper


def adjust_margin(obj, top=0, right=0, bottom=0, left=0):
    delta = (top, right, bottom, left)
    obj.margin = [m + d for m, d in zip(obj.margin, delta)]


def make_tooltips(**kwargs):
    return list(kwargs.items())



